using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using IDAutomation.DataMatrixServerControl;

namespace DataMatrixStreamCS
{
	/// <summary>
	/// Summary description for IDAutomationStreamingDataMatrix.
	/// </summary>
	public class IDAutomationStreamingDataMatrix : System.Web.UI.Page
	{
		protected IDAutomation.DataMatrixServerControl.DataMatrixBarcode DataMatrixBarcode1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			//During the page load event we will set all parameters for the control			
			//Checking the Parameters using Params.Get is NOT case sensitive.  
			//However, when we use the Equals method of the string data type it IS case sensitive

			//Set the Data to Encode
			if(Request.Params.Get("Barcode") != "" && Request.Params.Get("Barcode") != null)
				DataMatrixBarcode1.DataToEncode = Request.Params.Get("Barcode");
	        
			//Set the x dimension
			if(Request.Params.Get("X") != "" && Request.Params.Get("X") != null)
				DataMatrixBarcode1.XDimensionCM = Request.Params.Get("X");
        
			//set the left margin
			if(Request.Params.Get("Left_Margin") != "" && Request.Params.Get("Left_Margin") != null)
				DataMatrixBarcode1.LeftMarginCM = Request.Params.Get("Left_Margin");
	        
			//set the top margin
			if(Request.Params.Get("Top_Margin") != "" && Request.Params.Get("Top_Margin") != null)
				DataMatrixBarcode1.TopMarginCM = Request.Params.Get("Top_Margin");	
        
	        //Set the resolution of the returned image
			if(Request.Params.Get("IR") != "" && Request.Params.Get("IR") != null)
            try
			{
				DataMatrixBarcode1.ImageResolution = Convert.ToInt32(Request.Params.Get("IR"));
			}
            catch
			{
				System.Diagnostics.Debug.Write("Invalid entry for Image Resolution parameter");
			}
        

			//Determine if(ApplyTilde is turned on
			if(Request.Params.Get("PT") != "" && Request.Params.Get("PT") != null)
			{
				string tildeValue = Request.Params.Get("PT");
				if(tildeValue.Equals("Y") == true || tildeValue.Equals("Yes") == true || 
						tildeValue.Equals("True") == true || tildeValue.Equals("TRUE") == true ||
						tildeValue.Equals("true") == true || tildeValue.Equals("yes") == true ||
						tildeValue.Equals("y") == true)
					DataMatrixBarcode1.ApplyTilde = true;
				else
					DataMatrixBarcode1.ApplyTilde = false;
			}

			//set the rotation
			if(Request.Params.Get("Rotate") != "" && Request.Params.Get("Rotate") != null)
			{
				if(Request.Params.Get("Rotate").Equals("90"))
					DataMatrixBarcode1.RotationAngle = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.RotationAngles.Ninety_Degrees;
				else if(Request.Params.Get("Rotate").Equals("180"))
					DataMatrixBarcode1.RotationAngle = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.RotationAngles.One_Hundred_Eighty_Degrees;
				else if(Request.Params.Get("Rotate").Equals("270"))
					DataMatrixBarcode1.RotationAngle = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.RotationAngles.Two_Hundred_Seventy_Degrees;
				else
					DataMatrixBarcode1.RotationAngle = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.RotationAngles.Zero_Degrees;
			}

			//Set the encoding mode
			if(Request.Params.Get("MODE") != "" && Request.Params.Get("MODE") != null)
			{
				try
				{
					int modeValue = Convert.ToInt32(Request.Params.Get("MODE"));
					switch(modeValue)
					{
						case 0:
							DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Ascii;
							break;
						case 1:
							DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.C40;
							break;
						case 2:
							DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Text;
							break;
						case 3:
							DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Base256;
							break;
						case 4:
							DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Auto;
							break;
						default:
							DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Auto;
							break;
					}
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for DataMatrix Encoding Mode value");
					DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Auto;
				}        
			}
        
			//set the format of the matrix
			if(Request.Params.Get("PFMT") != "" && Request.Params.Get("PFMT") != null)
			{
				try
				{
					int formatValue = Convert.ToInt32(Request.Params.Get("PFMT"));
					switch(formatValue)
					{
						case 0:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.Auto;
							break;
						case 1:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C10X10;
							break;
						case 2:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C12X12;
							break;
						case 3:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C14X14;
							break;
						case 4:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C16X16;
							break;
						case 5:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C18X18;
							break;
						case 6:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C20X20;
							break;
						case 7:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C22X22;
							break;
						case 8:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C24X24;
							break;
						case 9:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C26X26;
							break;
						case 10:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C32X32;
							break;
						case 11:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C36X36;
							break;
						case 12:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C40X40;
							break;
						case 13:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C44X44;
							break;
						case 14:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C48X48;
							break;
						case 15:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C52X52;
							break;
						case 16:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C64X64;
							break;
						case 17:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C72X72;
							break;
						case 18:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C80X80;
							break;
						case 19:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C88X88;
							break;
						case 20:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C96X96;
							break;
						case 21:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C104X104;
							break;
						case 22:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C120X120;
							break;
						case 23:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C132X132;
							break;
						case 24:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C144X144;
							break;
						case 25:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C12X26;
							break;
						case 26:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C12X36;
							break;
						case 27:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C16X36;
							break;
						case 28:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C16X48;
							break;
						case 29:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C8X18;
							break;
						case 30:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.C8X32;
							break;
						default:
							DataMatrixBarcode1.PreferredFormat = DataMatrixBarcode.PreferredFormats.Auto;
							break;
					}
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for DataMatrix Preferred Format value");
					DataMatrixBarcode1.EncodingMode = IDAutomation.DataMatrixServerControl.DataMatrixBarcode.EncodingModes.Auto;
				}
			}
			//The following is an example for changing the font and colors of the image.
			//DataMatrixBarcode1.ForeColor = System.Drawing.Color.Yellow;
			//DataMatrixBarcode1.BackColor = System.Drawing.Color.Black;
			//DataMatrixBarcode1.Font.Name = "Georgia";
			//DataMatrixBarcode1.Font.Size = New FontUnit(16);

			if (Request.Params.Get("FORMAT") != "" && Request.Params.Get("FORMAT") != null)
			{
				if(Request.Params.Get("FORMAT").Equals("GIF"))
				{
					Response.ContentType="image/gif";
					DataMatrixBarcode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Gif);
				}
				else 
				{
					Response.ContentType="image/jpeg";
					DataMatrixBarcode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
				}
			}
			else 
			{
				Response.ContentType="image/gif";
				DataMatrixBarcode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
			}
	   
		}
		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
