using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace PDF417StreamCS
{
	/// <summary>
	/// Summary description for IDAutomationStreamingPDF417.
	/// </summary>
	public class IDAutomationStreamingPDF417 : System.Web.UI.Page
	{
		protected IDAutomation.PDF417ServerControl.PDF417Barcode PDF417Barcode1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			//Put user code to initialize the page here
			//During the page load event we will set all parameters for the control			
			//Checking the Parameters using Params.Get is NOT case sensitive.  
			//However, when we use the Equals method of the string data type it IS case sensitive

			//Set the Data to Encode
			if(Request.Params.Get("Barcode") != "" && Request.Params.Get("Barcode") != null)
				PDF417Barcode1.DataToEncode = Request.Params.Get("Barcode");
	        
			//Set the x dimension
			if(Request.Params.Get("X") != "" && Request.Params.Get("X") != null)
				PDF417Barcode1.XDimensionCM = Request.Params.Get("X");
	        
			//set the left margin
			if(Request.Params.Get("Left_Margin") != "" && Request.Params.Get("Left_Margin") != null)
				PDF417Barcode1.LeftMarginCM = Request.Params.Get("Left_Margin");
        
			//set the top margin
			if(Request.Params.Get("Top_Margin") != "" && Request.Params.Get("Top_Margin") != null)
				PDF417Barcode1.TopMarginCM = Request.Params.Get("Top_Margin");
	        
			//Set the ration of width to height for the bars
			if(Request.Params.Get("XYR") != "" && Request.Params.Get("XYR") != null)
			{
				try
				{
					PDF417Barcode1.XtoYRatio = Convert.ToInt32(Request.Params.Get("XYR"));
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for X to Y ratio");
				}
			}   
        
			//set the number of columns
			if(Request.Params.Get("COL") != "" && Request.Params.Get("COL") != null)
			{
				try
				{
					PDF417Barcode1.PDFColumns = Convert.ToInt32(Request.Params.Get("COL"));
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for PDF417 Columns");
				}
			}   

			//set the level of error correction
			if(Request.Params.Get("ECL") != "" && Request.Params.Get("ECL") != null)
			{
				try
				{
					PDF417Barcode1.PDFErrorCorrectionLevel = Convert.ToInt32(Request.Params.Get("ECL"));
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for PDF417 Error Correction Level");
				}
			}

			//set the number of rows.
			if(Request.Params.Get("ROWS") != "" && Request.Params.Get("ROWS") != null)
			{
				try
				{
					PDF417Barcode1.PDFRows = Convert.ToInt32(Request.Params.Get("ROWS"));
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for PDF417 Rows");
				}
			}

			//Set the resolution of the returned image
			if(Request.Params.Get("IR") != "" && Request.Params.Get("IR") != null)
			{
				try
				{
					PDF417Barcode1.ImageResolution = Convert.ToInt32(Request.Params.Get("IR"));
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for Image Resolution parameter");
				}
			}   
        
			//determine if the barcode should be truncated
			if(Request.Params.Get("TRN") != "" && Request.Params.Get("TRN") != null)
			{
				string trunValue = Request.Params.Get("TRN");
				if(trunValue.Equals("Y") == true || trunValue.Equals("Yes") == true || 
					trunValue.Equals("True") == true || trunValue.Equals("TRUE") == true || 
					trunValue.Equals("y") == true || trunValue.Equals("true") == true || 
					trunValue.Equals("yes") == true)
					PDF417Barcode1.Truncated = true;
				else
					PDF417Barcode1.Truncated = false;
			}
        
			//Determine if ApplyTilde is turned on
			if(Request.Params.Get("PT") != "" && Request.Params.Get("PT") != null)
			{
				string tildeValue = Request.Params.Get("PT");
				if(tildeValue.Equals("Y") == true || tildeValue.Equals("Yes") == true || 
					tildeValue.Equals("True") == true || tildeValue.Equals("TRUE") == true || 
					tildeValue.Equals("y") == true || tildeValue.Equals("true") == true || 
					tildeValue.Equals("yes") == true)
					PDF417Barcode1.ApplyTilde = true;
				else
					PDF417Barcode1.ApplyTilde = false;
			}
        
			//set the rotation
			if(Request.Params.Get("Rotate") != "" && Request.Params.Get("Rotate") != null)
			{
				if(Request.Params.Get("Rotate").Equals("90"))
					PDF417Barcode1.RotationAngle = IDAutomation.PDF417ServerControl.PDF417Barcode.RotationAngles.Ninety_Degrees;
				else if( Request.Params.Get("Rotate").Equals("180"))
					PDF417Barcode1.RotationAngle = IDAutomation.PDF417ServerControl.PDF417Barcode.RotationAngles.One_Hundred_Eighty_Degrees;
				else if( Request.Params.Get("Rotate").Equals("270"))
					PDF417Barcode1.RotationAngle = IDAutomation.PDF417ServerControl.PDF417Barcode.RotationAngles.Two_Hundred_Seventy_Degrees;
				else
					PDF417Barcode1.RotationAngle = IDAutomation.PDF417ServerControl.PDF417Barcode.RotationAngles.Zero_Degrees;
			}   
        
			//Set the encoding mode
			if(Request.Params.Get("MODE") != "" && Request.Params.Get("MODE") != null)
			{
				try
				{
					int modeValue = Convert.ToInt32(Request.Params.Get("MODE"));
					switch(modeValue)
					{
						case 1:
							PDF417Barcode1.PDFMode = IDAutomation.PDF417ServerControl.PDF417Barcode.PDF417Modes.Text;
							break;
						case 2:
							PDF417Barcode1.PDFMode = IDAutomation.PDF417ServerControl.PDF417Barcode.PDF417Modes.Binary;
							break;
						default:
							break;
					}
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for PDF Mode value");
				}
			}

			//The following is an example for changing the font and colors of the image.
			//PDF417Barcode1.ForeColor = System.Drawing.Color.Yellow;
			//PDF417Barcode1.BackColor = System.Drawing.Color.Black;
			//PDF417Barcode1.Font.Name = "Georgia";
			//PDF417Barcode1.Font.Size = New FontUnit(16);

			if(Request.Params.Get("FORMAT") != "" && Request.Params.Get("FORMAT") != null)
			{
				if(Request.Params.Get("FORMAT").Equals("JPEG"))
				{
					Response.ContentType="image/jpeg";
					PDF417Barcode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
				}
				else
				{
					Response.ContentType="image/gif";
					PDF417Barcode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Gif);
				}
			}
			else
			{
				Response.ContentType="image/gif";
				PDF417Barcode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Gif);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
